package cn.com.infosec.crypto.agreement;

import cn.com.infosec.crypto.BasicAgreement;
import cn.com.infosec.crypto.CipherParameters;
import cn.com.infosec.crypto.params.ECPrivateKeyParameters;
import cn.com.infosec.crypto.params.ECPublicKeyParameters;
import java.math.BigInteger;

public class ECDHBasicAgreement implements BasicAgreement {
   private ECPrivateKeyParameters key;

   public void init(CipherParameters key) {
      this.key = (ECPrivateKeyParameters)key;
   }

   public BigInteger calculateAgreement(CipherParameters pubKey) {
      return ((ECPublicKeyParameters)pubKey).getQ().multiply(this.key.getD()).getX().toBigInteger();
   }
}
